Doomsday Engine - Feature #1699

Feature # 7 (Progressed): Next-gen renderer (codename "Gloom")
Particle renderer 2.0

2014-01-03 12:40 - skyjake

Status: New Start date: 2014-01-03
Priority: High % Done: 0%
Assignee:

Category: Redesign

Target version: Rendering

Description

The current particle effects system has some severe bottlenecks (it does not utilize the GPU (shaders, VBOs), instead drawing all
particles in immediate mode) and some additional flexibility would be good for animating individual particles.

Also, sorting the particles is done pretty inefficiently: particles could for instance be divided into smaller buckets based on map
subdivision, and faraway buckets could be sorted less accurately, if sorted/drawn at all.

See: Improvement ideas by veirdo

Related issues:

Related to Feature #1698: Editor for particle generators New 2014-01-03
Related to Feature #1677: Square particle shape (option, as alternative to ro... New 2013-12-05
Related to Feature #1364: More options for pt_line type particles New 2004-09-23
Related to Feature #1745: Performance optimization Progressed  2014-04-09
Related to Feature #1168: Real decals: bulletholes, blastmarks, etc. New 2003-05-31
Related to Feature #1368: More Alt Start positions in Generators New 2004-12-11
Related to Feature #1546: Option for particle generator to hide sprite New 2011-09-29
Related to Feature #1242: Player weapon particle muzzle flashes (for external... New 2003-07-18
Related to Feature #1289: Flat-triggered particle generators created/destroye... New 2003-09-17
Related to Feature #1314: Particle spawn rate affected by mobj visibility New 2003-12-28
Related to Feature #1335: Random particle types New 2004-03-15
Related to Feature #1336: Random textured particle direction New 2004-03-24
Related to Feature #1430: Particle generator decorations (e.g., particles fro... New 2006-10-07
Related to Feature #1608: Integrate Doomsday Script Progressed  2013-10-22
Related to Feature #1542: Use hit origin for Damage generator New 2011-06-30
Related to Feature #1414: Generate particles when touching a plane New 2006-08-03
Related to Feature #390: Alignpitch/yaw flags for model particles New 2007-01-03
History

#1 - 2014-01-03 12:40 - skyjake

- Parent task set to #7

#2 - 2015-03-21 22:46 - skyjake

- Related to Feature #1745: Performance optimization added

#3 - 2017-01-22 08:51 - skyjake
- Related to Feature #1168: Real decals: bulletholes, blastmarks, etc. added

#4 - 2017-04-03 18:55 - skyjake

- Target version set to Rendering

#5 - 2019-11-29 15:27 - skyjake
- Related to Feature #1368: More Alt Start positions in Generators added
#6 - 2019-11-29 15:45 - skyjake
- Related to Feature #1546: Option for particle generator to hide sprite added

#7 - 2019-11-29 16:20 - skyjake

- Related to Feature #1242: Player weapon particle muzzle flashes (for external viewers only) added

#8 - 2019-11-29 16:23 - skyjake

- Related to Feature #1289: Flat-triggered particle generators created/destroyed on material change added

#9 - 2019-11-29 16:38 - skyjake
- Related to Feature #1314: Particle spawn rate affected by mobj visibility added

#10 - 2019-11-29 16:42 - skyjake
- Related to Feature #1335: Random particle types added

#11 - 2019-11-29 16:42 - skyjake
- Related to Feature #1336: Random textured particle direction added

#12 - 2019-11-29 18:40 - skyjake

- Related to Feature #1430: Particle generator decorations (e.g., particles from a wall) added

#13 - 2019-11-29 18:42 - skyjake
- Related to Feature #1608: Integrate Doomsday Script added

#14 - 2019-11-29 19:08 - skyjake
- Related to Feature #1542: Use hit origin for Damage generator added

#15 - 2019-11-29 19:19 - skyjake

- Related to Feature #1414: Generate particles when touching a plane added

#16 - 2019-11-29 23:09 - skyjake
- Related to Feature #390: Alignpitch/yaw flags for model particles added
